(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/router'), require('rxjs/operators'), require('rxjs/internal/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng7-bootstrap-breadcrumb', ['exports', '@angular/core', 'rxjs', '@angular/router', 'rxjs/operators', 'rxjs/internal/operators', '@angular/common'], factory) :
    (global = global || self, factory(global['ng7-bootstrap-breadcrumb'] = {}, global.ng.core, global.rxjs, global.ng.router, global.rxjs.operators, global.rxjs['internal/operators'], global.ng.common));
}(this, function (exports, core, rxjs, router, operators, operators$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Ng7BootstrapBreadcrumbService = /** @class */ (function () {
        function Ng7BootstrapBreadcrumbService() {
            this.breadcrumbLabels = new rxjs.BehaviorSubject([]);
        }
        /**
         * @param {?} labels
         * @return {?}
         */
        Ng7BootstrapBreadcrumbService.prototype.updateBreadcrumbLabels = /**
         * @param {?} labels
         * @return {?}
         */
        function (labels) {
            this.breadcrumbLabels.next(labels);
        };
        Ng7BootstrapBreadcrumbService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        Ng7BootstrapBreadcrumbService.ctorParameters = function () { return []; };
        /** @nocollapse */ Ng7BootstrapBreadcrumbService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function Ng7BootstrapBreadcrumbService_Factory() { return new Ng7BootstrapBreadcrumbService(); }, token: Ng7BootstrapBreadcrumbService, providedIn: "root" });
        return Ng7BootstrapBreadcrumbService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Ng7BootstrapBreadcrumbComponent = /** @class */ (function () {
        function Ng7BootstrapBreadcrumbComponent(activatedRoute, router, ng7BootstrapBreadcrumbService) {
            this.activatedRoute = activatedRoute;
            this.router = router;
            this.ng7BootstrapBreadcrumbService = ng7BootstrapBreadcrumbService;
            this.breadcrumb = [];
            this.breadCrumbData();
        }
        /**
         * @return {?}
         */
        Ng7BootstrapBreadcrumbComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.ng7BootstrapBreadcrumbService.breadcrumbLabels.subscribe((/**
             * @param {?} labelData
             * @return {?}
             */
            function (labelData) {
                var _loop_1 = function (label) {
                    if (labelData.hasOwnProperty(label)) {
                        _this.breadcrumb.map((/**
                         * @param {?} crumb
                         * @return {?}
                         */
                        function (crumb) {
                            var e_1, _a;
                            /** @type {?} */
                            var labelParams = crumb.label.match(/[^{{]+(?=\}})/g);
                            if (labelParams) {
                                try {
                                    for (var labelParams_1 = __values(labelParams), labelParams_1_1 = labelParams_1.next(); !labelParams_1_1.done; labelParams_1_1 = labelParams_1.next()) {
                                        var labelParam = labelParams_1_1.value;
                                        /** @type {?} */
                                        var dyanmicData = labelData[label];
                                        if (labelParam === label) {
                                            crumb.label = crumb.label.replace('{{' + labelParam + '}}', dyanmicData);
                                        }
                                    }
                                }
                                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                                finally {
                                    try {
                                        if (labelParams_1_1 && !labelParams_1_1.done && (_a = labelParams_1.return)) _a.call(labelParams_1);
                                    }
                                    finally { if (e_1) throw e_1.error; }
                                }
                            }
                        }));
                    }
                };
                for (var label in labelData) {
                    _loop_1(label);
                }
            }));
        };
        /**
         * @return {?}
         */
        Ng7BootstrapBreadcrumbComponent.prototype.breadCrumbData = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.router.events
                .pipe(operators.filter((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return event instanceof router.NavigationEnd; })))
                .pipe(operators$1.map((/**
             * @return {?}
             */
            function () { return _this.activatedRoute; })))
                .pipe(operators$1.map((/**
             * @param {?} route
             * @return {?}
             */
            function (route) {
                while (route.firstChild) {
                    route = route.firstChild;
                }
                return route;
            })))
                .pipe(operators.filter((/**
             * @param {?} route
             * @return {?}
             */
            function (route) { return route.outlet === router.PRIMARY_OUTLET; })))
                .subscribe((/**
             * @param {?} route
             * @return {?}
             */
            function (route) {
                if (route.snapshot.data.breadcrumb) {
                    /** @type {?} */
                    var breadcrumb = (JSON.parse(JSON.stringify(route.snapshot.data.breadcrumb)));
                    breadcrumb.map((/**
                     * @param {?} crumb
                     * @return {?}
                     */
                    function (crumb) {
                        var e_2, _a, e_3, _b;
                        /** @type {?} */
                        var urlChunks = crumb.url.split('/');
                        try {
                            for (var urlChunks_1 = __values(urlChunks), urlChunks_1_1 = urlChunks_1.next(); !urlChunks_1_1.done; urlChunks_1_1 = urlChunks_1.next()) {
                                var chunk = urlChunks_1_1.value;
                                if (chunk.includes(':')) {
                                    /** @type {?} */
                                    var paramID = chunk.replace(':', '');
                                    /** @type {?} */
                                    var routerParamID = route.snapshot.params[paramID];
                                    crumb.url = crumb.url.replace(":" + paramID, routerParamID);
                                }
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (urlChunks_1_1 && !urlChunks_1_1.done && (_a = urlChunks_1.return)) _a.call(urlChunks_1);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        /** @type {?} */
                        var labelParams = crumb.label.match(/[^{{]+(?=\}})/g);
                        if (labelParams) {
                            try {
                                for (var labelParams_2 = __values(labelParams), labelParams_2_1 = labelParams_2.next(); !labelParams_2_1.done; labelParams_2_1 = labelParams_2.next()) {
                                    var labelParam = labelParams_2_1.value;
                                    /** @type {?} */
                                    var routerParamID = route.snapshot.params[labelParam.trim()];
                                    if (routerParamID) {
                                        crumb.label = crumb.label.replace('{{' + labelParam + '}}', routerParamID);
                                    }
                                    else {
                                        // crumb.label = crumb.label.replace('{{' + labelParam + '}}', '');
                                    }
                                }
                            }
                            catch (e_3_1) { e_3 = { error: e_3_1 }; }
                            finally {
                                try {
                                    if (labelParams_2_1 && !labelParams_2_1.done && (_b = labelParams_2.return)) _b.call(labelParams_2);
                                }
                                finally { if (e_3) throw e_3.error; }
                            }
                        }
                    }));
                    _this.breadcrumb = breadcrumb;
                }
                else {
                    _this.breadcrumb = [];
                }
            }));
        };
        Ng7BootstrapBreadcrumbComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'app-ng7-bootstrap-breadcrumb',
                        template: "<nav aria-label=\"breadcrumb\">\n    <ol class=\"breadcrumb\" *ngIf=\"breadcrumb.length\">\n        <ng-container *ngFor=\"let item of breadcrumb; let i = index\">\n            <li class=\"breadcrumb-item\" [ngClass]=\"{'active': breadcrumb.length !== i+1}\">\n                <a *ngIf=\"item?.url\" [routerLink]=\"item?.url\">{{ item.label }}</a>\n                <span *ngIf=\"!item?.url\">{{ item.label }}</span>\n            </li>\n        </ng-container>\n    </ol>\n</nav>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        Ng7BootstrapBreadcrumbComponent.ctorParameters = function () { return [
            { type: router.ActivatedRoute },
            { type: router.Router },
            { type: Ng7BootstrapBreadcrumbService }
        ]; };
        return Ng7BootstrapBreadcrumbComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Ng7BootstrapBreadcrumbModule = /** @class */ (function () {
        function Ng7BootstrapBreadcrumbModule() {
        }
        Ng7BootstrapBreadcrumbModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [Ng7BootstrapBreadcrumbComponent],
                        imports: [
                            router.RouterModule,
                            common.CommonModule
                        ],
                        exports: [Ng7BootstrapBreadcrumbComponent]
                    },] }
        ];
        return Ng7BootstrapBreadcrumbModule;
    }());

    exports.Ng7BootstrapBreadcrumbComponent = Ng7BootstrapBreadcrumbComponent;
    exports.Ng7BootstrapBreadcrumbModule = Ng7BootstrapBreadcrumbModule;
    exports.Ng7BootstrapBreadcrumbService = Ng7BootstrapBreadcrumbService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ng7-bootstrap-breadcrumb.umd.js.map
